/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package gproboproxy;

import java.io.*;

import ec.*;
import ec.gp.*;

import robocode.*;
import robocode.security.*;
import gprobocode.*;

/**
 * <p>Title: GPTankRunner</p>
 * <p>Description: An adapting interface between Robocode and ECJ</p>
 * <p>Universita` degli Studi di Pavia</p>
 * @author Marco Piastra
 * @version 2003-5-30
 */

public class GPTankRunner extends GPTank {
    public static final String SERIALIZED_FNAME = "GPTank.ser";
    public static final String OUTPUT_FNAME = "GPTank.output";

    protected GPIndividual individual;

    public String serializedFilename() {
        return SERIALIZED_FNAME;
    }

    public String outputFilename() {
        return OUTPUT_FNAME;
    }

    public void setIndividual(GPIndividual ind) {
        individual = ind;
    }

    public GPIndividual getIndividual() {
        return individual;
    }

    public void run() {

        // Load individual from file
        try {
            String dir =
                ((RobocodeClassLoader) getClass().getClassLoader()).getClassDirectory();
            String filename = dir + File.separator + serializedFilename();

            out.println("Loading file " + filename);

            InputStream inStream = new FileInputStream(filename);

            uploadIndividual(inStream);
        }
        catch (Exception e) {
            e.printStackTrace();

            throw new RuntimeException("Error while reading individual " + e);
        }

        super.run();
    }

    public void storeOutput() {

        // Save output to file, if any
        if (output != null) {
            try {
                String dir =
                        ( (RobocodeClassLoader) getClass().getClassLoader()).
                        getClassDirectory();
                String filename = dir + File.separator + outputFilename();

                out.println("Saving to file " + filename);

                OutputStream outStream = new FileOutputStream(filename);

                output.store(outStream, filename);
            }
            catch (Exception e) {
                e.printStackTrace();

                throw new RuntimeException("Error while saving output " + e);
            }
        }
    }
}

